package xyz.brassgoggledcoders.boilerplate.lib.common.items;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.util.StatCollector;
import xyz.brassgoggledcoders.boilerplate.lib.BoilerplateLib;
import xyz.brassgoggledcoders.boilerplate.lib.client.ClientHelper;
import xyz.brassgoggledcoders.boilerplate.lib.client.models.IHasModel;
import xyz.brassgoggledcoders.boilerplate.lib.common.utils.StringUtils;

import java.util.List;

/**
 * @author warlordjones
 *
 */
public class ItemBase extends Item implements IHasModel
{
	protected String texturePath = "";
	protected String name;

	public ItemBase()
	{
		this("");
	}

	public ItemBase(String name)
	{
		this(name, "");
	}

	public ItemBase(String name, String texturePath)
	{
		super();
		this.name = name;
		this.func_77655_b(name);
		this.setRegistryName(name);
		if(!texturePath.isEmpty() && !texturePath.endsWith("/") && !texturePath.endsWith("\\"))
		{
			this.texturePath = texturePath + "/";
		}
		this.func_77637_a(BoilerplateLib.getMod().getCreativeTab());
	}

	@SuppressWarnings("all")
	@Override
	public void func_77624_a(ItemStack stack, EntityPlayer entityPlayer, List list, boolean bool)
	{
		if (stack.func_77952_i() > 0)
		{
			if (!StatCollector.func_74838_a(this.func_77658_a() + "." + stack.func_77952_i() + ".desc").contains("item."))
			{
				if (ClientHelper.isShiftKeyDown())
				{
					this.getWrappedDesc(list, stack);
				}
				else
				{
					list.add(ClientHelper.shiftForInfo);
				}
			}
		}
		else
		{
			if (!StatCollector.func_74838_a(this.func_77658_a() + ".desc").contains("item."))
			{
				if (ClientHelper.isShiftKeyDown())
				{
					this.getWrappedDesc(list, stack);
				}
				else
				{
					list.add(ClientHelper.shiftForInfo);
				}
			}
		}
	}

	public void getWrappedDesc(List<String> list, ItemStack stack)
	{
		String[] wrappedDesc;
		if (stack.func_77952_i() > 0)
		{
			wrappedDesc = StringUtils.wrap(StatCollector.func_74838_a(this.func_77658_a() + "." + stack.func_77952_i() + ".desc"), 35);
		}
		else
		{
			wrappedDesc = StringUtils.wrap(StatCollector.func_74838_a(this.func_77658_a() + ".desc"), 35);
		}
		for (String element : wrappedDesc)
		{
			list.add(element.trim());
		}
	}

	public void getWrappedDescAlt(List<String> list, ItemStack stack)
	{
		String[] wrappedDesc;
		if (stack.func_77952_i() > 0)
		{
			wrappedDesc = StringUtils.wrap(StatCollector.func_74838_a(this.func_77658_a() + "." + stack.func_77952_i() + ".desc"), 35);
		}
		else
		{
			wrappedDesc = StringUtils.wrap(StatCollector.func_74838_a(this.func_77658_a() + ".desc_alt"), 35);
		}
		for (String element : wrappedDesc)
		{
			list.add(element.trim());
		}
	}

	@Override
	public String[] getResourceLocations()
	{
		return new String[] {texturePath + name};
	}
}
